Attribute VB_Name = "aMouseMod"
Option Explicit
'========================================================
'MX2125 Mouse Driver - by Rob Tauler (TechnoRobbo) 2010
'
'   Use  Mouse Glove Control Panel to change settings
'========================================================
Private Enum CommType
    CT_Quit = 0
    CT_Setx = 1
    CT_SetY = 2
    CT_SetZero = 3
    CT_SetPort = 4
    CT_SetTimeout = 5
    CT_Toggle = 6
    CT_Reset = 7
    
End Enum

Private Type MOUSEINPUT
  dx As Long
  dy As Long
  mouseData As Long
  dwFlags As Long
  time As Long
  dwExtraInfo As Long
End Type

Const INPUT_MOUSE = 0
Const INPUT_KEYBOARD = 1
Const INPUT_HARDWARE = 2

Type GENERALINPUT
  dwType As Long
  mouse As MOUSEINPUT
End Type

Const MOUSEEVENTF_ABSOLUTE = &H8000 ' absolute move
Const MOUSEEVENTF_LEFTDOWN = &H2 ' left button down
Const MOUSEEVENTF_LEFTUP = &H4 ' left button up
Const MOUSEEVENTF_MOVE = &H1 ' mouse move
Const MOUSEEVENTF_MIDDLEDOWN = &H20
Const MOUSEEVENTF_MIDDLEUP = &H40
Const MOUSEEVENTF_RIGHTDOWN = &H8
Const MOUSEEVENTF_RIGHTUP = &H10
Const MB_DEFBUTTON1 = &H0&
Const MB_DEFBUTTON2 = &H100&
Const MB_DEFBUTTON3 = &H200&
Const MB_ICONASTERISK = &H40&
Const MB_ICONEXCLAMATION = &H30&
Const MB_ICONHAND = &H10&
Const MB_ICONINFORMATION = MB_ICONASTERISK
Const MB_ICONQUESTION = &H20&
Const MB_ICONSTOP = MB_ICONHAND
Const MB_OK = &H0&
Const MB_OKCANCEL = &H1&
Const MB_YESNO = &H4&
Const MB_YESNOCANCEL = &H3&
Const MB_ABORTRETRYIGNORE = &H2&
Const MB_RETRYCANCEL = &H5&
Const OCR_NORMAL = 32512
Const IDC_ARROW = 32512&


Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function SetSystemCursor Lib "user32" (ByVal hcur As Long, ByVal id As Long) As Long
Private Declare Function CopyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long

Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function SendInput Lib "user32.dll" (ByVal nInputs As Long, pInputs As GENERALINPUT, ByVal cbSize As Long) As Long
Private Declare Function GetMessageExtraInfo Lib "user32" () As Long

Const GWL_WNDPROC = (-4)
Const WM_PASTE = &H302

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
   
Dim lpPrevWndProc As Long
Dim lHwnd As Long

Dim BuffL As Byte, BuffR As Byte
Dim lastL As Byte, lastR As Byte
Dim port As Integer, counter As Long, Ncounter As Long
Dim XSense As Single, YSense As Single, NoCursor As Boolean
Dim OffTime As Single
Dim XZero As Single, YZero As Single
Dim XZeroB As Single, YZeroB As Single
Dim lngStatus As Long
Dim Connected As Boolean
Dim hcurOn As Long, hcurOld As Long, hcurTemp
Sub Main()
If App.PrevInstance = True Then End

Dim p As MOUSEINPUT, g As GENERALINPUT, x As String, z As String, y As Variant
Dim i As Integer
On Error GoTo GetOutBaby


port = Val(GetSetting("MouseGlove", "Settings", "Port", "1"))
XSense = Val(GetSetting("MouseGlove", "Settings", "XSense", "25"))
If XSense = 0 Then XSense = 100
If XSense < 50 Then XSense = 50
If XSense > 200 Then XSense = 200

YSense = Val(GetSetting("MouseGlove", "Settings", "YSense", "25"))
If YSense = 0 Then YSense = 100
If YSense < 50 Then YSense = 50
If YSense > 200 Then YSense = 200

OffTime = Val(GetSetting("MouseGlove", "Settings", "OffTime", "10"))
If OffTime = 0 Then OffTime = 10
If OffTime < 5 Then OffTime = 5
If OffTime > 100 Then OffTime = 100

XZero = Val(GetSetting("MouseGlove", "Settings", "XZero", "2500"))
YZero = Val(GetSetting("MouseGlove", "Settings", "YZero", "2500"))
Connected = False

' Initialize Communications
lngStatus = CommOpen(port, "COM" & CStr(port), _
    "baud=9600 parity=N data=8 stop=1")

If lngStatus <> 0 Then GoTo GetOutBaby

DoEvents

Connected = True

'load and set sursors
hcurOn = LoadCursor(App.hInstance, 101)
hcurOld = CopyIcon(LoadCursor(ByVal 0&, IDC_ARROW))
hcurTemp = CopyIcon(hcurOn)
SetCursor hcurTemp
SetSystemCursor hcurTemp, OCR_NORMAL
NoCursor = False

lHwnd = FindWindow(vbNullString, "MouseGlove")

If Connected Then pHook


Do While Connected
    x = ""
    Do
        '==========
        lngStatus = CommRead(port, z, 1)
        If lngStatus < 0 Then
            Connected = False
            Exit Do
        End If
    
        If z = "!" Then
            x = ""
        ElseIf z = Chr(13) Then
            y = vb5split(x, ",")
        Else
            x = x & z
        End If
    Loop Until z = Chr(13) Or Not Connected
    If Connected Then
        '==========
        If UBound(y) = 3 Then
            '=========
            If Val(y(2)) = 1 And Val(y(3)) = 1 Then
                counter = counter + 1
                Ncounter = Ncounter + 1
                
                'toggle glove
                If counter = OffTime And NoCursor = False Then
                    
                    counter = 0
                    NoCursor = True
                    
                    hcurTemp = CopyIcon(hcurOld)
                    SetCursor hcurTemp
                    SetSystemCursor hcurTemp, OCR_NORMAL
                    
                ElseIf counter = OffTime And NoCursor = True Then
                    
                    NoCursor = False
                    
                    hcurTemp = CopyIcon(hcurOn)
                    SetCursor hcurTemp
                    SetSystemCursor hcurTemp, OCR_NORMAL
                    
                End If
                
                'shutdown
                If Ncounter = 150 Then
                    g.dwType = INPUT_MOUSE
                    g.mouse.dx = 0
                    g.mouse.dy = 0
                    g.mouse.mouseData = 0
                    g.mouse.dwFlags = MOUSEEVENTF_LEFTUP Or MOUSEEVENTF_RIGHTUP
                    g.mouse.dwExtraInfo = GetMessageExtraInfo()
                    g.mouse.time = 0
                    SendInput 1, g, Len(g)
                    
                    MessageBox GetForegroundWindow, "Mouse Glove Disabled", "Mouse Glove", MB_OK
                    Connected = False
                End If
            ElseIf NoCursor = False Then
                counter = 0
                Ncounter = 0
                g.dwType = INPUT_MOUSE
                
                XZeroB = y(1)
                
                If XZeroB < 1900 Then XZeroB = 1900
                If XZeroB > 3600 Then XZeroB = 3600
                
                If XZeroB >= XZero Then
                    g.mouse.dx = ((XZero - XZeroB) / (3100 - XZero)) ^ 2 * -XSense
                Else
                    g.mouse.dx = ((XZeroB - XZero) / (XZero - 1900)) ^ 2 * XSense
                End If
                
                YZeroB = y(0)
                
                If YZeroB < 1900 Then YZeroB = 1900
                If YZeroB > 3600 Then YZeroB = 3600
                
                If YZeroB >= YZero Then
                    g.mouse.dy = ((YZero - YZeroB) / (3100 - YZero)) ^ 2 * YSense
                Else
                    g.mouse.dy = ((YZeroB - YZero) / (YZero - 1900)) ^ 2 * -YSense
                End If
                

                g.mouse.mouseData = 0
                g.mouse.dwFlags = MOUSEEVENTF_MOVE
                
                'debounce
                BuffL = (BuffL * 2 + Val(y(2))) And 3
                BuffR = (BuffR * 2 + Val(y(3))) And 3
                
                If BuffL = 3 Then
                    If lastL = 0 Then g.mouse.dwFlags = g.mouse.dwFlags Or MOUSEEVENTF_LEFTDOWN
                    lastL = 1
                ElseIf BuffL = 0 Then
                    If lastL = 1 Then g.mouse.dwFlags = g.mouse.dwFlags Or MOUSEEVENTF_LEFTUP
                    lastL = 0
                End If
                
                
                If BuffR = 3 Then
                    If lastR = 0 Then g.mouse.dwFlags = g.mouse.dwFlags Or MOUSEEVENTF_RIGHTDOWN
                    lastR = 1
                ElseIf BuffR = 0 Then
                    If lastR = 1 Then g.mouse.dwFlags = g.mouse.dwFlags Or MOUSEEVENTF_RIGHTUP
                    lastR = 0
                End If
                
                g.mouse.dwExtraInfo = GetMessageExtraInfo()
                g.mouse.time = 0
                SendInput 1, g, Len(g)
            ElseIf NoCursor = True Then
                XZeroB = y(1)
                
                If XZeroB < 1900 Then XZeroB = 1900
                If XZeroB > 3600 Then XZeroB = 3600
                
                YZeroB = y(0)
                
                If YZeroB < 1900 Then YZeroB = 1900
                If YZeroB > 3600 Then YZeroB = 3600
                
            End If
            '=========
        End If
        '=========
        DoEvents
    End If
Loop

pUnhook
Call CommClose(port)
DoEvents

'destroy cursors here
SetCursor hcurOld
SetSystemCursor hcurOld, OCR_NORMAL
DestroyCursor (hcurOn)

End

Exit Sub

GetOutBaby:
    Call CommClose(port)
    
    'destroy cursors here
    SetSystemCursor hcurOld, OCR_NORMAL
    DestroyCursor (hcurOn)

    MessageBox GetForegroundWindow, "Driver Error!!!" & vbNewLine _
        & "Check Comm Port in Control Panel", "Mouse Glove Error", MB_OK
    End

End Sub

Private Function vb5split(ByVal srch As String, ByVal fnd As String)
Dim temp() As String, i As Integer, j As Integer, x As Integer

ReDim temp(0)
temp(0) = srch

If srch = "" Then
    temp(0) = ""
    GoTo vb5splitout
End If

i = 1 'pointer
x = 0 'dimension

Do While InStr(temp(x), fnd) > 0
    ReDim Preserve temp(x + 1)
    temp(x + 1) = Mid(temp(x), InStr(temp(x), fnd) + Len(fnd))
    temp(x) = Left(temp(x), InStr(temp(x), fnd) - 1)
    x = x + 1
Loop


vb5splitout:
vb5split = temp

End Function

Public Sub pUnhook()
Call SetWindowLong(lHwnd, GWL_WNDPROC, lpPrevWndProc)
End Sub
Public Sub pHook()
lpPrevWndProc = SetWindowLong(lHwnd, GWL_WNDPROC, AddressOf fWindowProc)
End Sub

Function fWindowProc(ByVal hw As Long, ByVal uMsg As Long, _
         ByVal wParam As Long, ByVal lParam As Long) As Long

If uMsg = WM_PASTE Then

    Select Case wParam
        Case CT_Quit 'exit program
            Connected = False
        Case CT_Toggle 'toggle cursor control
            If NoCursor = False Then
                counter = 0
                NoCursor = True
                
                hcurTemp = CopyIcon(hcurOld)
                SetCursor hcurTemp
                SetSystemCursor hcurTemp, OCR_NORMAL
                
            ElseIf NoCursor = True Then
                
                NoCursor = False
                counter = 0
                hcurTemp = CopyIcon(hcurOn)
                SetCursor hcurTemp
                SetSystemCursor hcurTemp, OCR_NORMAL
            End If
        Case CT_SetPort
            SaveSetting "MouseGlove", "Settings", "Port", lParam
        Case CT_Setx
            XSense = lParam
            If XSense = 0 Then XSense = 25
            If XSense < 50 Then XSense = 10
            If XSense > 1000 Then XSense = 100
            SaveSetting "MouseGlove", "Settings", "XSense", XSense
        Case CT_SetY
            YSense = lParam
            If YSense = 0 Then YSense = 25
            If YSense < 50 Then YSense = 50
            If YSense > 1000 Then YSense = 100
            SaveSetting "MouseGlove", "Settings", "YSense", YSense
        Case CT_SetTimeout
            OffTime = lParam
            If OffTime = 0 Then OffTime = 10
            If OffTime < 5 Then OffTime = 5
            If OffTime > 100 Then OffTime = 100
            SaveSetting "MouseGlove", "Settings", "OffTime", OffTime
        Case CT_SetZero
            If XZeroB = 0 Then XZeroB = 2500
            If YZeroB = 0 Then YZeroB = 2500
            XZero = XZeroB
            YZero = YZeroB
            SaveSetting "MouseGlove", "Settings", "XZero", XZero
            SaveSetting "MouseGlove", "Settings", "YZero", YZero
        Case CT_Reset
            XSense = 25
            SaveSetting "MouseGlove", "Settings", "XSense", XSense
            YSense = 25
            SaveSetting "MouseGlove", "Settings", "YSense", YSense
            OffTime = 10
            SaveSetting "MouseGlove", "Settings", "OffTime", OffTime
            XZero = 2500
            YZero = 2500
            SaveSetting "MouseGlove", "Settings", "XZero", XZero
            SaveSetting "MouseGlove", "Settings", "YZero", YZero
        
    End Select
End If

fWindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function

